﻿using System;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls;

namespace TreeView_SL_Simple_MVVM
{
	public class DataItem : ViewModelBase
	{
		private string imageSource;
		private ObservableCollection<DataItem> children;
		private string header;
		private bool isExpanded;
		private bool isLoadingOnDemand;
		private bool isLoadOnDemandEnabled;
		private bool isVisible;

		private bool iChecked;

		public DataItem()
		{
			this.isVisible = true;
			this.isLoadOnDemandEnabled = true;
			this.isLoadingOnDemand = false;
			this.isExpanded = true;
			this.children = new ObservableCollection<DataItem>();
		}

		public bool IsVisible 
		{
			get
			{
				return this.isVisible;
			}
			set
			{
				if (this.isVisible != value)
				{
					this.isVisible = value;
					this.OnPropertyChanged("IsVisible");
				}
			}
		}

		public bool IsItemExpanded 
		{
			get
			{
				return this.isExpanded;
			}
			set
			{
				if (this.isExpanded != value)
				{
					this.isExpanded = value;
					this.OnPropertyChanged("IsItemExpanded");
				}
			}
		}

		public bool IsItemLoadingOnDemand 
		{
			get
			{
				return this.isLoadingOnDemand;
			}
			set
			{
				if (this.isLoadingOnDemand != value)
				{
					this.isLoadingOnDemand = value;
					this.OnPropertyChanged("IsItemLoadingOnDemand");
				}
			}
		}

		public bool IsLoadOnDemandEnabled 
		{
			get
			{
				return this.isLoadOnDemandEnabled;
			}
			set
			{
				if (this.isLoadOnDemandEnabled != value)
				{
					this.isLoadOnDemandEnabled = value;
					this.OnPropertyChanged("IsLoadOnDemandEnabled");
				}
			}
		}

		public string ImageSource 
		{
			get
			{
				return this.imageSource;
			}
			set
			{
				if (this.imageSource != value)
				{
					this.imageSource = value;
					this.OnPropertyChanged("ImageSource");
				}
			}
		}

		public ObservableCollection<DataItem> Children 
		{
			get
			{
				return this.children;
			}
			set
			{
				if (this.children != value)
				{
					this.children = value;
					this.OnPropertyChanged("Children");
				}
			}
		}

		public string Header 
		{
			get
			{
				return this.header;
			}
			set
			{
				if (this.header != value)
				{
					this.header = value;
					this.OnPropertyChanged("Header");
				}
			}
		}

		public bool IsChecked 
		{
			get
			{
				return this.iChecked;
			}
			set
			{
				if (this.iChecked != value)
				{
					this.iChecked = value;
					this.OnPropertyChanged("IsChecked");
				}
			}
		}
	}
}