﻿using System;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Threading;
using Telerik.Windows.Controls;

namespace TreeView_SL_Simple_MVVM
{
	public class ViewModel:ViewModelBase
	{
		private readonly string[] images = new string[]
		{
			"Chrysanthemum.jpg",
			"Desert.jpg",
			"Hydrangeas.jpg",
			"Jellyfish.jpg",
			"Koala.jpg",
			"Lighthouse.jpg",
			"Penguins.jpg",
			"Tulips.jpg"
		};

		public ViewModel()
		{
			this.Items = new ObservableCollection<DataItem>();
			this.GenerateItems();
		}

		public ObservableCollection<DataItem> Items { get; set; }

		private void GenerateItems()
		{
			sbyte nextImage = -1;
			for (int i = 0; i < 5; i++)
			{

				nextImage++;
				if (nextImage == 7)
				{
					nextImage = 1;
				}

				this.Items.Add(new DataItem()
				{
					Header = string.Format("Item {0}", i + 1),
					ImageSource = string.Format("Images/{0}", this.images[nextImage]),
					IsItemExpanded = false
				});

				for (int j = 0; j < 2; j++)
				{
					if (nextImage == images.Count() - 1)
					{
						nextImage = -1;
					}
					nextImage++;
					this.Items[i].Children.Add(new DataItem()
					{
						Header = string.Format("Sub Item {0}.{1}", i + 1, j + 1),
						ImageSource = string.Format("Images/{0}", this.images[nextImage]),
						IsItemExpanded = true
					});
				}
			}
		}

		public void CustomMethod(DataItem item)
		{
			item.Children.Add(new DataItem() { Header = "This is loaded on demand", ImageSource = "Images/Tulips.jpg", IsChecked = true });
		}
	}
}
